function enableBadge(badgeElement)
{
    var badgesList = document.getElementById(badgeElement).getElementsByTagName("span");
    for (i = 0; i < badgesList.length; i++)
    {
        badgesList[i].classList.add("badge-warning");
        badgesList[i].classList.remove("text-muted");
        badgesList[i].classList.remove("badge-light");
    }
}

function disableBadge(badgeElement)
{
    var badgesList = document.getElementById(badgeElement).getElementsByTagName("span");
    for (i = 0; i < badgesList.length; i++)
    {
        badgesList[i].classList.remove("badge-warning");
        badgesList[i].classList.add("text-muted");
        badgesList[i].classList.add("badge-light");
    }
}

/*
Disable some Classical fields/labels based on whether isApplyClassical enabled
*/
function classical()
{
    //do nothing
}

/*
Disable some Artist Artwork fields/labels based on whether isAddArtistArtwork enabled
*/
function artistartwork()
{
    //donothing
}



function add_preferred_countries()
{
    allCountries      = document.getElementById('preferred_countries_all');
    selectedCountries = document.getElementById('preferred_countries_selected');
    moveBetweenList(allCountries, selectedCountries);

    // Loop through the second list and select each option for submit
    Array.prototype.slice.call(
        selectedCountries
        .querySelectorAll("option"))
        .forEach(function(opt)
        {
            opt.selected = "selected";
        }
    );
}

function remove_preferred_countries()
{
    allCountries      = document.getElementById('preferred_countries_all');
    selectedCountries = document.getElementById('preferred_countries_selected');
    moveBetweenList(selectedCountries, allCountries);

    allCountries.value = "";

    // Loop through the second list and select each option for submit
    Array.prototype.slice
        .call(selectedCountries.querySelectorAll("option"))
        .forEach(function(opt)
        {
            opt.selected = "selected";
        }
    );
}

function sortAlphabetically(selectName)
{
        var functionsToSort = $(selectName + ' ' + 'option');
        functionsToSort.sort(function(a,b){
           var textA = a.text.toUpperCase();
           var textB = b.text.toUpperCase();
           return (textA < textB) ? -1 : (textA > textB) ? 1 : 0;
        });
        $(selectName).html(functionsToSort);
}

/**
* Add error msg to modal (remove existing messages first
*/
function addAlertToModal(alerts, msg)
{
    removeAllAlerts(alerts);
    var alert = document.createElement("div");
    var msg   = document.createTextNode(msg);
    alert.className = "alert alert-danger";
    //alert.role = "alert";
    alert.appendChild(msg);
    alerts.appendChild(alert);
}

function removeAllAlerts(alerts)
{
    while (alerts.hasChildNodes()) {
      alerts.removeChild(alerts.lastChild);
    }
}

$('#addallartisttree').jstree
(
    {
        'plugins' : ['themes','html_data','ui','cookie'],
        'core' :
        {
            'data' :
            {
                'url' : '/foldertree',
                'dataType' : 'json',
                'data' : function (node) {
                  return { 'id' : node.id };
                }
            }
        }
    }
)
.bind('select_node.jstree',
    function (e, data)
    {
        var objNode = data.instance.get_node(data.selected[0]);
        var input = document.getElementById('allArtistArtworkFolder');
        if (!input.disabled)
        {
               input.value=objNode.id;
        }
    }
)
;
