function enableBadge(badgeElement)
{
    var badgesList = document.getElementById(badgeElement).getElementsByTagName("span");
    for (i = 0; i < badgesList.length; i++)
    {
        badgesList[i].classList.add("badge-secondary");
        badgesList[i].classList.remove("text-muted");
        badgesList[i].classList.remove("badge-light");
    }
}

function disableBadge(badgeElement)
{
    var badgesList = document.getElementById(badgeElement).getElementsByTagName("span");
    for (i = 0; i < badgesList.length; i++)
    {
        badgesList[i].classList.remove("badge-secondary");
        badgesList[i].classList.add("text-muted");
        badgesList[i].classList.add("badge-light");
    }
}

/*
Disable some Classical fields/labels based on whether isApplyClassical enabled
*/
function classical()
{
    cb0 = document.getElementById('isApplyClassical').checked;
	if(cb0)
	{
		enableInputAndLabel('isAddComposerToAlbumTitle');
		enableInputAndLabel('isRemoveClassicalAlbumArtist');
		enableInputAndLabel('isAddComposerToMinimWork');
		enableInputAndLabel('isAddComposerToMinimGroup');
		enableInputAndLabel('isAlwaysUseArtistType');
		enableInputAndLabel('movementToTitle');
		enableInputAndLabel('workToGroup');
		enableInputAndLabel('saveOperaFormat');
		enableInputAndLabel('classicalTrackArtist');
		document.getElementById('classicalFieldsNeverModifyButton').disabled = false;
        document.getElementById('classicalFieldsModifyIfEmptyButton').disabled = false;
        document.getElementById('classicalFieldsNeverModifyLabel').className="optionlabel";
        document.getElementById('classicalFieldsModifyIfEmptyLabel').className="optionlabel";
        enableBadge('classicalFieldsNeverModifySpan');
        enableBadge('classicalFieldsModifyIfEmptySpan');
	}
	else
	{
		disableInputAndLabel('isAddComposerToAlbumTitle');
		disableInputAndLabel('isRemoveClassicalAlbumArtist');
		disableInputAndLabel('isAddComposerToMinimWork');
        disableInputAndLabel('isAddComposerToMinimGroup');
		disableInputAndLabel('isAlwaysUseArtistType');
		disableInputAndLabel('movementToTitle');
		disableInputAndLabel('workToGroup');
		disableInputAndLabel('saveOperaFormat');
		disableInputAndLabel('classicalTrackArtist');
		document.getElementById('classicalFieldsNeverModifyButton').disabled = true;
        document.getElementById('classicalFieldsModifyIfEmptyButton').disabled = true;
        document.getElementById('classicalFieldsNeverModifyLabel').className="optionlabeldisabled";
        document.getElementById('classicalFieldsModifyIfEmptyLabel').className="optionlabeldisabled";
        disableBadge('classicalFieldsNeverModifySpan');
        disableBadge('classicalFieldsModifyIfEmptySpan');
    }
}

function albumartwork()
{
    cb0 = document.getElementById('isFindFrontCoverart').checked;
	if(cb0)
	{
		enableInputAndLabel('embedArtwork');
		enableInputAndLabel('fsArtwork');
		enableInputAndLabel('saveArtworkFilename');
	}
	else
	{
		disableInputAndLabel('embedArtwork');
        disableInputAndLabel('fsArtwork');
		disableInputAndLabel('saveArtworkFilename');
    }
}

function albumbackartwork()
{
    cb0 = document.getElementById('isFindBackCover').checked;
	if(cb0)
	{
		enableInputAndLabel('embedBackCover');
		enableInputAndLabel('fsBackCover');
		enableInputAndLabel('saveBackCoverFilename');
	}
	else
	{
		disableInputAndLabel('embedBackCover');
        disableInputAndLabel('fsBackCover');
		disableInputAndLabel('saveBackCoverFilename');
    }
}
/*
Disable some Artist Artwork fields/labels based on whether isAddArtistArtwork enabled
*/
function artistartwork()
{
    cb0 = document.getElementById('isAddArtistArtwork').checked;
	if(cb0)
	{
        enableInputAndLabel('minArtistImageSize');
        enableInputAndLabel('maxArtistImageSize');
        enableInputAndLabel('fsArtistArtwork');
        enableInputAndLabel('isSaveAllArtistArtworkFolder');
        document.getElementById('allArtistArtworkFolder').disabled = false;
        document.getElementById('addallartisttree').disabled = false;
        document.getElementById('artistArtworkButton').disabled = false;
        document.getElementById('artistArtworkLabel').className="optionlabel";
        enableBadge('artistArtworkSpan');
	}
	else
	{
	    disableInputAndLabel('minArtistImageSize');
        disableInputAndLabel('maxArtistImageSize');
        disableInputAndLabel('fsArtistArtwork');
        disableInputAndLabel('isSaveAllArtistArtworkFolder');
        document.getElementById('allArtistArtworkFolder').disabled = true;
        document.getElementById('addallartisttree').disabled = true;
        document.getElementById('artistArtworkButton').disabled = true;
        document.getElementById('artistArtworkLabel').className="optionlabeldisabled";
        disableBadge('artistArtworkSpan');
    }
}


function add_preferred_countries()
{
    allCountries      = document.getElementById('preferred_countries_all');
    selectedCountries = document.getElementById('preferred_countries_selected');
    moveBetweenList(allCountries, selectedCountries);

    // Loop through the second list and select each option for submit
    Array.prototype.slice.call(
        selectedCountries
        .querySelectorAll("option"))
        .forEach(function(opt)
        {
            opt.selected = "selected";
        }
    );
}

function remove_preferred_countries()
{
    allCountries      = document.getElementById('preferred_countries_all');
    selectedCountries = document.getElementById('preferred_countries_selected');
    moveBetweenList(selectedCountries, allCountries);

    allCountries.value = "";

    // Loop through the second list and select each option for submit
    Array.prototype.slice
        .call(selectedCountries.querySelectorAll("option"))
        .forEach(function(opt)
        {
            opt.selected = "selected";
        }
    );
}

function sortAlphabetically(selectName)
{
        var functionsToSort = $(selectName + ' ' + 'option');
        functionsToSort.sort(function(a,b){
           var textA = a.text.toUpperCase();
           var textB = b.text.toUpperCase();
           return (textA < textB) ? -1 : (textA > textB) ? 1 : 0;
        });
        $(selectName).html(functionsToSort);
}

/**
* Add error msg to modal (remove existing messages first
*/
function addAlertToModal(alerts, msg)
{
    removeAllAlerts(alerts);
    var alert = document.createElement("div");
    var msg   = document.createTextNode(msg);
    alert.className = "alert alert-danger";
    //alert.role = "alert";
    alert.appendChild(msg);
    alerts.appendChild(alert);
}

function removeAllAlerts(alerts)
{
    while (alerts.hasChildNodes()) {
      alerts.removeChild(alerts.lastChild);
    }
}

function checkMbDiscogsId()
{
    var textField = document.getElementById('musicbrainzOrDiscogsId').value;
	if(textField.length > 0)
	{
	    document.getElementById('isForceAllowLowScoringMatch').disabled = false;
	}
	else
	{
		document.getElementById('isForceAllowLowScoringMatch').disabled = true;
    }
}

$('#addallartisttree').jstree
(
    {
        'plugins' : ['themes','html_data','ui','cookie'],
        'core' :
        {
            'data' :
            {
                'url' : '/fixsongs.add_artist_artwork_foldertree',
                'dataType' : 'json',
                'data' : function (node) {
                  return { 'id' : node.id };
                }
            }
        }
    }
)
.bind('select_node.jstree',
    function (e, data)
    {
        var objNode = data.instance.get_node(data.selected[0]);
        var input = document.getElementById('allArtistArtworkFolder');
        if (!input.disabled)
        {
               input.value=objNode.id;
        }
    }
)
;

/*
Shift first section of subfolder to basefolder
*/
function shift_left(separator, index)
{
    try
    {
        basefolder 			= document.getElementById('basefolder'+index);
        subfolder  			= document.getElementById('subfolder'+index);
        basefolderVal 	    = basefolder.value;
        subfolderVal		= subfolder.value;
        if(subfolderVal.length > 0)
        {
            if(subfolderVal.indexOf(separator)> -1)
            {
                basefolder.value = basefolder.value + separator + subfolderVal.substring(0,subfolderVal.indexOf(separator));
                subfolder.value  = subfolderVal.substring(subfolderVal.indexOf(separator) + 1,subfolderVal.length);
            }
            else
            {
                basefolder.value = basefolder.value + separator + subfolderVal;
                subfolder.value  = '';
            }
        }
    }
    catch(e)
    {
        alert(e);
    }
}

/*
Shift last section of basefolder (unless only root left) to start of subfolder
*/
function shift_right(separator, index)
{
    try
    {
        basefolder 			= document.getElementById('basefolder'+index);
        subfolder  			= document.getElementById('subfolder'+index);
        basefolderVal 	= basefolder.value;
        subfolderVal		= subfolder.value;
        if(basefolderVal.indexOf(separator)>-1)
        {
            subfolder.value = basefolderVal.substring(basefolderVal.lastIndexOf(separator) + 1, basefolderVal.length)
            if(subfolderVal.length > 0)
            {
                subfolder.value = subfolder.value + separator + subfolderVal;
            }
            basefolder.value = basefolderVal.substring(0,basefolderVal.lastIndexOf(separator));
        }
    }
    catch(e)
    {
        alert(e);
    }
}


/*
* Init Never Modify modal
*/
$('#fieldsNeverModifyModal').on('show.bs.modal', function (e) {

 initFieldsModal("fieldsNeverModify");
});

/*
* Init Modify If Empty modal
*/
$('#fieldsModifyIfEmptyModal').on('show.bs.modal', function (e) {

 initFieldsModal("fieldsModifyIfEmpty");
});

/*
* Init Classical Never Modify modal
*/
$('#classicalFieldsNeverModifyModal').on('show.bs.modal', function (e) {

 initFieldsModal("classicalFieldsNeverModify");
});

/*
* Init Classical Modify If Empty modal
*/
$('#classicalFieldsModifyIfEmptyModal').on('show.bs.modal', function (e) {

 initFieldsModal("classicalFieldsModifyIfEmpty");
});

/*
* Init Involved People modal
*/
$('#addRolesToInvolvedPeopleModal').on('show.bs.modal', function (e) {

 initFieldsModal("addRolesToInvolvedPeople");
});

/*
* Init Multi Values Fields modal
*/
$('#fieldsAsMultiValueModal').on('show.bs.modal', function (e) {

 initFieldsModal("fieldsAsMultiValue");
});


/*
* Init Artwork Delete modal
*/
$('#artistArtworkModal').on('show.bs.modal', function (e) {

 initFieldsModal("artistArtwork");
});




