
/**
* Sort contents of select alphabetically
*/
function sortAlphabetically(selectName)
{
        var functionsToSort = $(selectName + ' ' + 'option');
        functionsToSort.sort(function(a,b){
           var textA = a.text.toUpperCase();
           var textB = b.text.toUpperCase();
           return (textA < textB) ? -1 : (textA > textB) ? 1 : 0;
        });
        $(selectName).html(functionsToSort);
}

//editmodal

/*
* Clone Profile
*/
function cloneProfile(actionNameRoot)
{
   var newProfile     = document.getElementById("clone_profile");
   var newProfileName = newProfile.value;
   var origProfile    = profiles.options[profiles.selectedIndex].value;
   var index          = profiles.selectedIndex;

   if (newProfileName.length==0)
   {
        addAlertToModal(document.getElementById("cloneprofilemodalAlerts"),'New name not entered');
        return;
   }

   var xhr = new XMLHttpRequest();
   xhr.open('POST', actionNameRoot + '.clone_profile', true);
   xhr.setRequestHeader("Content-type", "text/plain");
   xhr.send(origProfile+"\0"+newProfileName);
   xhr.onreadystatechange = function() {
       if (this.readyState == 4 && this.status == 200)
       {
           if(xhr.responseText.startsWith('ok'))
           {
               document.getElementById("clone_profile").value = "";
               $('#cloneprofilemodal').modal('hide');
               var newProfile = document.createElement("option");
               newProfile.text  = newProfileName;
               newProfile.value = xhr.responseText.substring(3);
               profiles.add(newProfile);
               profiles.selectedIndex = profiles.length - 1;

               //TODO is not ordered alphabetically, means wrong one selected but also Default not put at start
               removeAllAlerts(document.getElementById("messages"));
           }
       }
   };
}

/**
* After user has renamed Profile in UI send request to server to actually do the rename
* then afterwards update with new name (TODO)
*/
function renameProfile(actionNameRoot)
{
   var profiles       = document.getElementById("profiles");
   var newProfileName = document.getElementById("rename_profile").value;
   var origProfile    = profiles.options[profiles.selectedIndex].value;
   var index          = profiles.selectedIndex;

   if(newProfileName.length==0)
   {
       addAlertToModal(document.getElementById("renameprofilemodalAlerts"),'New name not entered');
       return;
   }
   var xhr = new XMLHttpRequest();
   xhr.open('POST', actionNameRoot + '.rename_profile', true);
   xhr.setRequestHeader("Content-type", "text/plain");
   xhr.send(origProfile+"\0"+newProfileName);
   xhr.onreadystatechange = function() {
       if (this.readyState == 4 && this.status == 200)
       {
           if(xhr.responseText.startsWith('ok'))
           {
               document.getElementById("rename_profile").value = "";
               $('#renameprofilemodal').modal('hide');
               profiles[index].text  = newProfileName;
               sortAlphabetically("#profiles");
           }
           else
           {
               addAlertToModal(document.getElementById("messages"),xhr.responseText.substring(6));
           }
       }
   };
}

function selectProfile(actionNameRoot)
{
   var origProfile    = profiles.options[profiles.selectedIndex].value;
   var index          = profiles.selectedIndex;

   var xhr = new XMLHttpRequest();
   xhr.open('POST', actionNameRoot + '.select_profile', true);
   xhr.setRequestHeader("Content-type", "text/plain");
   xhr.send(origProfile);
   xhr.onreadystatechange = function() {
       if (this.readyState == 4 && this.status == 200)
       {
       }
   };
}

/*
* Delete selected Profile
*/
function deleteProfile(actionNameRoot)
{
    var profiles = document.getElementById("profiles");
    var xhr = new XMLHttpRequest();
    xhr.open('POST', actionNameRoot + '.delete_profile', true);
    xhr.setRequestHeader("Content-type", "text/plain");
    xhr.send(profiles.options[profiles.selectedIndex].value);
    xhr.onreadystatechange = function() {
        if (this.readyState == 4 && this.status == 200)
        {
            if(xhr.responseText=='ok')
            {
                var index = profiles.selectedIndex;
                profiles.remove(index);
            }
            else
            {
                  addAlertToModal(document.getElementById("messages"),xhr.responseText.substring(6));
            }
        }
    };
}

/**
* Add error msg to modal (remove existing messages first
*/
function addAlertToModal(alerts, msg)
{
    removeAllAlerts(alerts);
    var alert = document.createElement("div");
    var msg   = document.createTextNode(msg);
    alert.className = "alert alert-danger";
    //alert.role = "alert";
    alert.appendChild(msg);
    alerts.appendChild(alert);
}

function removeAllAlerts(alerts)
{
    while (alerts.hasChildNodes()) {
      alerts.removeChild(alerts.lastChild);
    }
}

